
library(MASS)
source("SIBoost.r")

### reading data set ###
DATA<-read.table("noisyminer.txt",header=TRUE)
y.org<-DATA[,10]
X.org<-DATA[,-c(1,10)]

set.seed(1)
M<-500
n.rep<-1
lambda.h<-1

                                    
family=poisson()
monotone="TRUE"
lambda.h<-1
nu.f=0.1
nu.h=0.1
m.h<-100
deg.h<-3
K<-5
n.train<-floor(length(y.org)*2/3)
n.test<-length(y.org)-n.train
n<-nrow(X.org)
f <- ceiling(n/K)
s <- sample(rep(1:K, f), n.train)
ms <- max(s)
split.M<-matrix(0,n.train,K)
K<-5
### split for CV ###
for(j in 1:ms)
{
  j.out <- c(1:n.train)[(s == j)]
  j.in <- c(1:n.train)[(s!= j)]
  split.M[j.in,j]<- 1###
}
train.sample<-sample(seq(1,n), n.train)

### train data
y.train<-y.org[train.sample]
X.train<-X.org[train.sample,]
### standardization of the test data
X.test<-scale(X.org[-train.sample,],center=colMeans(X.train),scale=sd(X.train))
y.test<-y.org[-train.sample]

### Estimation with CV
AUX<-CV.SI.LIN.BOOST.cut(y.train,X=X.train,split=split.M,m.h=m.h,nu.h=nu.h,nu.f=nu.f,lambda.h=lambda.h,deg.h=deg.h,M=M,family=family,monotone=monotone)  #
### optimal model without cut
NON.CUT<-opt.model(AUX)
PRED.NON.CUT<-predict.SI.LIN.BOOST.cut(NON.CUT,y.test,X.test)
### optimal model without cut
CUT<-opt.model.cut(AUX)
PRED.CUT<-predict.SI.LIN.BOOST.cut(CUT,y.test,X.test)
